package com.example.nto.domain.entity;


import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import java.util.List;

@Data
@Entity
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "passages")
public class Passage {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private long id;

    @Column(name = "passage", unique = true)
    @NotBlank(message = "Название не может быть пустым!")
    @Size(max = 100, message = "Максимальная длина названия 100 символов!")
    private String passage;

    @OneToMany(mappedBy = "passage")
    private List<Visit> visits;
}
