package com.example.nto.domain.exception.advice;

import com.example.nto.domain.exception.CodeNotFoundException;
import com.example.nto.domain.exception.EmployeeNotFoundException;
import com.example.nto.domain.exception.SomethingWentWrongException;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;

@ControllerAdvice
public class GlobalExceptionalHandler {
    // При выбрасывании исключений EmployeeNotFoundException и CodeNotFoundException возвращает клиенту код 401.
    // При выбрасывании исключения SomethingWentWrongException возвращает 400.

    @ExceptionHandler(EmployeeNotFoundException.class)
    public ResponseEntity<HttpStatus> handlerEmployeeNotFoundException(EmployeeNotFoundException e) {
        return new ResponseEntity<>(HttpStatus.UNAUTHORIZED);
    }

    @ExceptionHandler(CodeNotFoundException.class)
    public ResponseEntity<HttpStatus> handlerCodeNotFoundException(CodeNotFoundException e) {
        return new ResponseEntity<>(HttpStatus.UNAUTHORIZED);
    }

    @ExceptionHandler(SomethingWentWrongException.class)
    public ResponseEntity<HttpStatus> handlerSomethingWentWrongException(SomethingWentWrongException e) {
        return new ResponseEntity<>(HttpStatus.BAD_REQUEST);
    }
}
